/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreMissingvalue.TCoreMissingvaluePath;
import de.ship.db.tables.TDmMissingcode.TDmMissingcodePath;
import de.ship.db.tables.records.TDmMissingvalueRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TDmMissingvalue extends TableImpl<TDmMissingvalueRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_dm_missingvalue</code>
     */
    public static final TDmMissingvalue T_DM_MISSINGVALUE = new TDmMissingvalue();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TDmMissingvalueRecord> getRecordType() {
        return TDmMissingvalueRecord.class;
    }

    /**
     * The column <code>common_dd.t_dm_missingvalue.lastchange</code>.
     */
    public final TableField<TDmMissingvalueRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_dm_missingvalue.pk</code>.
     */
    public final TableField<TDmMissingvalueRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_dm_missingvalue.fk_missingcode</code>.
     */
    public final TableField<TDmMissingvalueRecord, Integer> FK_MISSINGCODE = createField(DSL.name("fk_missingcode"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_dm_missingvalue.fk_core_missingvalue</code>.
     */
    public final TableField<TDmMissingvalueRecord, Integer> FK_CORE_MISSINGVALUE = createField(DSL.name("fk_core_missingvalue"), SQLDataType.INTEGER.nullable(false), this, "");

    private TDmMissingvalue(Name alias, Table<TDmMissingvalueRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TDmMissingvalue(Name alias, Table<TDmMissingvalueRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_missingvalue</code> table
     * reference
     */
    public TDmMissingvalue(String alias) {
        this(DSL.name(alias), T_DM_MISSINGVALUE);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_missingvalue</code> table
     * reference
     */
    public TDmMissingvalue(Name alias) {
        this(alias, T_DM_MISSINGVALUE);
    }

    /**
     * Create a <code>common_dd.t_dm_missingvalue</code> table reference
     */
    public TDmMissingvalue() {
        this(DSL.name("t_dm_missingvalue"), null);
    }

    public <O extends Record> TDmMissingvalue(Table<O> path, ForeignKey<O, TDmMissingvalueRecord> childPath, InverseForeignKey<O, TDmMissingvalueRecord> parentPath) {
        super(path, childPath, parentPath, T_DM_MISSINGVALUE);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TDmMissingvaluePath extends TDmMissingvalue implements Path<TDmMissingvalueRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TDmMissingvaluePath(Table<O> path, ForeignKey<O, TDmMissingvalueRecord> childPath, InverseForeignKey<O, TDmMissingvalueRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TDmMissingvaluePath(Name alias, Table<TDmMissingvalueRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TDmMissingvaluePath as(String alias) {
            return new TDmMissingvaluePath(DSL.name(alias), this);
        }

        @Override
        public TDmMissingvaluePath as(Name alias) {
            return new TDmMissingvaluePath(alias, this);
        }

        @Override
        public TDmMissingvaluePath as(Table<?> alias) {
            return new TDmMissingvaluePath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TDmMissingvalueRecord, Integer> getIdentity() {
        return (Identity<TDmMissingvalueRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TDmMissingvalueRecord> getPrimaryKey() {
        return Keys.PK_DM_MISSINGVALUE;
    }

    @Override
    public List<UniqueKey<TDmMissingvalueRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_DM_MISSINGVALUE);
    }

    @Override
    public List<ForeignKey<TDmMissingvalueRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_DM_MISSINGVALUE__FK_DM_MV_MC, Keys.T_DM_MISSINGVALUE__FK_DM_MV_MV);
    }

    private transient TDmMissingcodePath _tDmMissingcode;

    /**
     * Get the implicit join path to the <code>common_dd.t_dm_missingcode</code>
     * table.
     */
    public TDmMissingcodePath tDmMissingcode() {
        if (_tDmMissingcode == null)
            _tDmMissingcode = new TDmMissingcodePath(this, Keys.T_DM_MISSINGVALUE__FK_DM_MV_MC, null);

        return _tDmMissingcode;
    }

    private transient TCoreMissingvaluePath _tCoreMissingvalue;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_missingvalue</code> table.
     */
    public TCoreMissingvaluePath tCoreMissingvalue() {
        if (_tCoreMissingvalue == null)
            _tCoreMissingvalue = new TCoreMissingvaluePath(this, Keys.T_DM_MISSINGVALUE__FK_DM_MV_MV, null);

        return _tCoreMissingvalue;
    }

    @Override
    public TDmMissingvalue as(String alias) {
        return new TDmMissingvalue(DSL.name(alias), this);
    }

    @Override
    public TDmMissingvalue as(Name alias) {
        return new TDmMissingvalue(alias, this);
    }

    @Override
    public TDmMissingvalue as(Table<?> alias) {
        return new TDmMissingvalue(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmMissingvalue rename(String name) {
        return new TDmMissingvalue(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmMissingvalue rename(Name name) {
        return new TDmMissingvalue(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmMissingvalue rename(Table<?> name) {
        return new TDmMissingvalue(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmMissingvalue where(Condition condition) {
        return new TDmMissingvalue(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmMissingvalue where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmMissingvalue where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmMissingvalue where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmMissingvalue where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmMissingvalue where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmMissingvalue where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmMissingvalue where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmMissingvalue whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmMissingvalue whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
